/* feynhiggsfast.f -- translated by f2c (version 19991025).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"
#include <math.h>

/* Common Block Declarations */

struct {
    doublereal mw, mz, sw2, mt, mtrun, mb, as, alphasmz, gs, el, gf;
} smpara_;

#define smpara_1 smpara_

struct {
    doublereal cf, eps, pi;
    doublecomplex i__;
} para_;

#define para_1 para_

struct {
    doublereal mst1, mst2, stt, ctt, delmst, msb1, msb2, stb, ctb, msusy, 
	    msusytl, msusytr, msusybl, msusybr, mtlr, mblr, au, ad, mmm, mgl, 
	    mue, beta, alpha, tb, ma;
} susypara_;

#define susypara_1 susypara_

struct {
    integer selec2, selec3;
} selec_;

#define selec_1 selec_

struct {
    doublereal mhh, mlh;
} higgsmass_;

#define higgsmass_1 higgsmass_

struct {
    doublereal mlhlle1, mlhlle2, mlhllediag1, mlhllediag2, mhhllediag1, 
	    mhhllediag2, alphadiag1, alphadiag2, mhptree, mhp;
} lle_;

#define lle_1 lle_

/* Table of constant values */

static integer c__9 = 9;
static integer c__1 = 1;
static integer c__4 = 4;

/* Main program */ feynhiggsfast_()
{
    /* System generated locals */
    real r__1, r__2, r__3, r__4;

    /* Builtin functions */

    /* Local variables */
    extern /* Subroutine */ int feynhiggsfastsub_();
    static doublereal delrholimit;



    para_1.pi = 3.14159265897;
    smpara_1.mz = 91.187;
    smpara_1.mw = 80.39;
    smpara_1.gf = 1.16639e-5;
    smpara_1.as = .1095;
    smpara_1.alphasmz = .118;
    para_1.cf = 1.3333333333333333;
    para_1.eps = 1e-10;
    para_1.i__.r = 0., para_1.i__.i = 1.;
    smpara_1.mb = 4.5;
    delrholimit = .0013;

    selec_1.selec2 = 4;
    selec_1.selec3 = 1;
    delrholimit = .0013;

/*    susypara_1.tb = (float)10.;
    susypara_1.msusytl = (float)800.;
    susypara_1.msusy = susypara_1.msusytl;
    susypara_1.msusytr = (float)800.;
    susypara_1.msusybl = susypara_1.msusy;
    susypara_1.msusybr = susypara_1.msusy;
    susypara_1.mue = -400.;
    susypara_1.ma = (float)300.;
    susypara_1.mtlr = (float)1e3;
*/
	
	
	
    puts("Your parameters:");
    puts("Msusy(top-left), Msusy(top-right), MtLR");
    puts("tb, MT, MA, Mue");
	
	printf("%f %f %f\n",susypara_1.msusytl,susypara_1.msusytr,susypara_1.mtlr);
    printf("%f %f %f %f\n",
			susypara_1.tb,smpara_1.mt,susypara_1.ma,susypara_1.mue);
    
    feynhiggsfastsub_();
    puts( "-------------------------------------------------");
    puts( "The results: light Higgs    heavy Higgs     alpha");
    
    if ((real) susypara_1.mst1 >= 65. && (real) susypara_1.msb2 >= 65.) {
	printf( "mh-2loop: %f %f %f\n",lle_1.mlhllediag2,lle_1.mhhllediag2,
	                 lle_1.alphadiag2);
					 
	puts("-------------------------------------------------");
	printf( "charged Higgs, tree: %f loop: %f\n",
			lle_1.mhptree,  lle_1.mhp);
	
    } else {
	puts("unphysical higgs masses");
    }
} /* MAIN__ */


double fhf1(double tb, double mu, double ml, double mr, double at, 
		double ma, double mt, double tp)
{
	int sw;
	static double mt_sav=0.0;
	
	if(ml==0.0 && mr==0.0)
		return 0.0;
	
	if(tb!=susypara_1.tb || mu!=susypara_1.mue ||
		ml!=susypara_1.msusytl || mr!=susypara_1.msusytr ||
		at!=susypara_1.mtlr || ma!=susypara_1.ma || mt_sav != mt)
	{
		susypara_1.tb=tb;
		susypara_1.mue=mu;
		susypara_1.msusytl=ml;
		susypara_1.msusytr=mr;
		susypara_1.mtlr=at;
		susypara_1.ma=ma;
		susypara_1.msusy = susypara_1.msusytl;
		susypara_1.msusybl = susypara_1.msusy;
  		susypara_1.msusybr = susypara_1.msusy;
		smpara_1.mt = mt; mt_sav=mt;
		
	    feynhiggsfast_();
	}
	
	sw=(int)floor(tp+0.5);
	if(sw<1 || sw>5)
	{
		puts("fhf1: wrong selector");
		return 0;
	}
	
	switch(sw)
	{
		case 1:
				return lle_1.mlhllediag2;
		case 2: 
				return lle_1.mhhllediag2;
		case 3:
				return sin(lle_1.alphadiag2);
		case 4:
				return cos(lle_1.alphadiag2);
		case 5:
				return lle_1.mhp;
	}
	return 0;
}
